def power_mod(x, n, q):
    if n == 0: return 1
    else:
        y = power_mod((x * x) % q, n // 2, q)
        if n % 2 == 0: return y
        else: return (x * y) % q

def residu(x, q):
    return power_mod(x, (q - 1) // 2, q) == 1

def chi(q, x):
    if x == 0: return 0
    elif residu(x, q): return 1
    else: return -1

def log2(n):
    if n == 1: return 0
    elif n % 2 != 0: return -1
    else: 
        k = log2 (n // 2)
        if k == -1: return -1
        else: return k + 1

def least_factor(n):
    k = 2
    while k * k <= n and n % k != 0: k += 1
    if k * k > n: return n
    else:
        return k

def is_prime(n):
    if n <= 1: return False
    else: return least_factor(n) == n

def insert(p, f):
    if f != [] and f[0][0] == p:
        return [(p, f[0][1] + 1)] + f[1:]
    else:
        return [(p, 1)] + f

def factor(n):
    if n == 1: return []
    else:
        p = least_factor(n)
        f = factor(n // p)
        return insert(p, f)

def expand_factor(n):
    s = factor(n)
    s1 = []
    for (p, k) in s:
        s1 += k * [p]
    return s1

def subtract(s, x):
    for k in range(len(s)):
        if s[k] == x:
            return s[:k] + s[k+1:]
    return s

def partitions_set(E):
    if E == []: return [[]]
    else:
        a = E[0]
        E1 = E[1:]
        P1 = partitions_set(E1)
        P2 = [X + [[a]] for X in P1]
        P3 = [subtract(U, Y) + [Y + [a]] for U in P1 for Y in U]
        return P2 + P3

def product(s):
    p = 1
    for x in s: p *= x
    return p

def remove_duplicates(s):
    s1 = []
    for k in range(len(s) - 1):
        if s[k] != s[k+1]: s1.append(s[k])
    s1.append(s[len(s)-1])
    return s1

def partitions(n):
    ds = expand_factor(n)
    ps = partitions_set(ds)
    p1 = [[product(s) for s in p] for p in ps]
    for s in p1:
        s.sort()
    p1.sort()
    p1 = remove_duplicates(p1)
    return p1


